/**
 * Description: CmExchangeCodeBatch控制器
 * Copyright:   Copyright (c)2015
 * Company:     江苏三六五网络股份有限公司
 * @author:     江苏三六五网络股份有限公司
 * @version:    1.0
 * Create at:   2015-11-03 下午 17:36:18
 *  
 * Modification History:
 * Date         Author      Version     Description
 * ------------------------------------------------------------------
 * 2015-11-03   江苏三六五网络股份有限公司   1.0         Initial
 */
package com.house365.web.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.validation.BindingResult;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.servlet.mvc.support.RedirectAttributes;
import org.springside.modules.web.Servlets;

import com.house365.beans.entity.CmExchangeCodeBatchEntity;
import com.house365.beans.system.Page;
import com.house365.beans.vo.CmExchangeCodeBatchVo;
import com.house365.web.system.controller.BaseController;
import com.house365.web.util.StringUtils;
import com.house365.ws.beans.request.CmExchangeCodeBatchListRequest;
import com.house365.ws.beans.request.CmExchangeCodeBatchRequest;
import com.house365.ws.beans.response.CmExchangeCodeBatchListResponse;
import com.house365.ws.beans.response.CmExchangeCodeBatchResponse;
import com.house365.ws.interfaces.server.ICmExchangeCodeBatch;

/**
 * CmExchangeCodeBatch控制器<br>
 * 
 * @author 江苏三六五网络股份有限公司
 * @version 1.0, 2015-11-03
 * @see
 * @since 1.0
 */
@Controller
@RequestMapping("/cmexchangecodebatch")
public class CmExchangeCodeBatchController extends BaseController {

	/**
	 * 自动注入CmExchangeCodeBatchWS实现
	 */
	@Autowired
	private ICmExchangeCodeBatch cmExchangeCodeBatch;

	/**
	 * 去新增CmExchangeCodeBatch
	 * 
	 * @return 结果视图
	 */
	@RequestMapping(value = "", params = "action=create")
	public String createForm(Model model){
		model.addAttribute("action", "create");
		return getAutoUrl("form");
	}

	/**
	 * 新增CmExchangeCodeBatch
	 * 
	 * @param cmExchangeCodeBatch CmExchangeCodeBatch页面表单对象
	 * @param result 表单验证数据
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "", method = { RequestMethod.POST})
	public String createCmExchangeCodeBatch(@Valid CmExchangeCodeBatchVo vo, BindingResult result, RedirectAttributes redirectAttributes, Model model){
		CmExchangeCodeBatchEntity entity = vo.getEntity();
		model.addAttribute("entity", entity);
		// subValidation(result, entity);
		// 表单验证无误,进行提交
		if (result.hasErrors()) {
		    model.addAttribute("action", "create");
            addErrorMessage(model, result.getFieldError().getDefaultMessage());
            return getAutoUrl("form");
		} else {
		    try {
                CmExchangeCodeBatchRequest request = new CmExchangeCodeBatchRequest();
                request.setEntity(entity);
                CmExchangeCodeBatchResponse response = cmExchangeCodeBatch
                        .addCmExchangeCodeBatch(request);
                Integer id = response.getEntity().getId();
                return "redirect:/cmexchangecodebatch/" + id;
            } catch (Exception ex) {
                addErrorMessage(model, ex.getMessage());
                model.addAttribute("action", "create");
                return getAutoUrl("form");
            }
		}
	}

	/**
	 * 删除CmExchangeCodeBatch
	 * 
	 * @param id CmExchangeCodeBatch页面表单对象唯一标识
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.DELETE })
	@ResponseStatus(HttpStatus.OK)
	public void delete(@PathVariable String id){
	    if(!StringUtils.isEmpty(id))
        {
            if(id.contains(","))
            {
                String[] ids = id.split(",");
                for (int i = 0; i < ids.length; i++) {
                    CmExchangeCodeBatchResponse response = cmExchangeCodeBatch.deleteCmExchangeCodeBatchById(Integer.valueOf(ids[i]));
                }
            }
            else
            {
                CmExchangeCodeBatchResponse response = cmExchangeCodeBatch.deleteCmExchangeCodeBatchById(Integer.valueOf(id));
            }
        }
	}

	/**
	 * 去查看CmExchangeCodeBatch
	 * 
	 * @param id
	 *            CmExchangeCodeBatch页面表单对象唯一标识
	 * @param request
	 *            请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.GET })
	public String showForm(@PathVariable(value = "id") Integer id, Model model) {
        CmExchangeCodeBatchResponse response = cmExchangeCodeBatch
                .getCmExchangeCodeBatchById(id);
        model.addAttribute("entity", response.getEntity());
        return getAutoUrl("form");
	}

	/**
	 * 去修改CmExchangeCodeBatch
	 * 
	 * @param id CmExchangeCodeBatch页面表单对象唯一标识
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.GET}, params = "action=edit")
	public String updateForm(@PathVariable(value = "id") Integer id, Model model){
        CmExchangeCodeBatchResponse response = cmExchangeCodeBatch
                .getCmExchangeCodeBatchById(id);
        model.addAttribute("entity", response.getEntity());
		model.addAttribute("action", "edit");
		return getAutoUrl("form");
	}

	/**
	 * 修改CmExchangeCodeBatch
	 * 
	 * @param cmExchangeCodeBatch CmExchangeCodeBatch页面表单对象
	 * @param result 表单验证数据
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "/{id}", method = { RequestMethod.POST})
	public String updateCmExchangeCodeBatch(@Valid CmExchangeCodeBatchVo vo, BindingResult result, @PathVariable Integer id, RedirectAttributes redirectAttributes, Model model){
		CmExchangeCodeBatchEntity entity = vo.getEntity();
		model.addAttribute("entity", entity);
		// subValidation(result, entity);
		// 表单验证无误,进行提交
		if (result.hasErrors()) {
		    model.addAttribute("action", "create");
            addErrorMessage(model, result.getFieldError().getDefaultMessage());
            return getAutoUrl("form");
		} else {
            try {
                CmExchangeCodeBatchRequest request = new CmExchangeCodeBatchRequest();
                request.setEntity(entity);
                @SuppressWarnings("unused")
                CmExchangeCodeBatchResponse rersponse = cmExchangeCodeBatch
                        .updateCmExchangeCodeBatch(request);
                redirectAttributes.addAttribute("message", "更新成功");
                return "redirect:/cmexchangecodebatch/" + entity.getId();
            } catch (Exception ex) {
                addErrorMessage(model, ex.getMessage());
                model.addAttribute("action", "edit");
                return getAutoUrl("form");
            }
		}
	}

	/**
	 * 查询CmExchangeCodeBatch
	 * 
	 * @param cmExchangeCodeBatch CmExchangeCodeBatch页面表单对象
	 * @param page 分页配置
	 * @param request 请求对象
	 * @return 结果视图
	 */
	@RequestMapping(value = "", method = RequestMethod.GET)
	public String list (Integer number, Model model, HttpServletRequest request) {
		// 获取查询条件
		Map<String, Object> searchParams = Servlets.getParametersStartingWith(
				request, "search_");
		Page page = new Page();
		if (null != number) {
			page.setCurrentPage(number);
		}
		CmExchangeCodeBatchListRequest listRequest = new CmExchangeCodeBatchListRequest();
        listRequest.setPaging(page);
        listRequest.setSearchParams(searchParams);
        CmExchangeCodeBatchListResponse response = cmExchangeCodeBatch.getCmExchangeCodeBatchList(listRequest);
        model.addAttribute("page", response.getPaging());
        model.addAttribute("cmExchangeCodeBatchs", response.getObjectList());
        model.addAttribute("searchParams", Servlets
                .encodeParameterStringWithPrefix(searchParams, "search_"));
		return getAutoUrl();
	}
}
